/* These flags control compilation. Define either PC, OPENVIEW or UNIX.
 * For PCs define either CURSES or PCSPECIFIC.
 * For the PC, the best combination is PC and PCSPECIFIC although PC
 * and CURSES allows the curses version to be tested.
 *
 * For non-OPENVIEW UNIX, you must have CURSES set.
 * 
 * 1999.2.3 - the PC version needs 'Turbo C Tools version 5.00' by Blaise
 * Computing, which is unlikely to still be available. IT also needs the
 * PC-dependent source 'ibm.c'. This was last compiled by me in 1994 (???)
 * with Borland's Turbo-C 1.5. As this is just too hard and unlikely to
 * be of further interest, I will no longer support the DOS version.
 * If this is a problem, please contact me bhepple@bit.net.au

    Contact info:
    bhepple@bit.net.au
    http://www.bit.net.au/~bhepple/dcalc

    Copyright (C) 1999 Bob Hepple

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.

 */

#undef	PC
#define	UNIX 1
#undef OPENVIEW

#ifdef PC
#undef   CURSES
#define  PCSPECIFIC      1
/* Set this if you want a TSR function with mouse capture */
#undef	 TSR
#endif

/* If you set PCSPECIFIC then you need to compile and link dcalc.c with
 * ibm.c as well as the special version of ivctrl.obj
 * (munged to support the 101-key keyboard) as well as Blaise's tct_t1s.lib.
 * Compile everything with TurboC 1.5 in the small model.
 *
 * For CURSES, you need to compile and link curse.c and dcalc.c with the curses
 * library.
 *
 * For OPENVIEW, you need to compile and link openview.c, ov_ui.c, ov_stubs.c
 * and dcalc.c with the appropriate libraries.
 */

/* End of flags. The previous flags are all you should have to touch. */
/**********************************************************************/

#ifdef UNIX
#define CURSES		1
#undef  PCSPECIFIC
#undef  OPENVIEW
#endif

#ifdef __TURBOC__
#define REVERSE_BYTES	1
#else
#define REVERSE_BYTES	0
#endif

#undef REVERSE_BYTES
#define REVERSE_BYTES	1

#define ASCIIZ '\0'
#define SPECIAL ASCIIZ

#ifndef TRUE
#define TRUE	1
#define FALSE	0
#endif

/* Keys we are interested in ... */
#define BELL	7
#define SPACE	' '
#define COMMA   ','
#define BACKSPACE 8
#define ESCAPE	27

#define COMMAND int

/* COMMANDS (in addition to 'normal' keys ... */
#define MIN_COMMAND 0x200
#define ASCIIM	0x200
#define	DEGREE	0x201
#define	RADIAN	0x202
#define	PROG	0x203
#define	SCI	0x204
#define	FIN	0x205
#define	STAT	0x206
#define	PLACES	0x207
#define FLOAT	0x208
#define ENG  	0x209
#define BIN  	0x20a
#define OCT  	0x20b
#define DEC  	0x20c
#define HEX  	0x20d
#define IP  	0x210

#define INV  	0x211
#define SIN  	0x212
#define COS  	0x213
#define TAN  	0x214
#define SINH 	0x215
#define COSH 	0x216
#define TANH 	0x217
#define LOGE 	0x218
#define LOG10	0x219

#define SQR  	0x220
#define ROOT 	0x221
#define CUBE 	0x222
#define CROOT	0x223
#define FRC  	0x224
#define INT  	0x225
#define ETOX	0x226
#define RECI	0x227
#define PI	0x228
#define E	0x229
#define HMS	0x22a
#define RTOP	0x22b
#define DTOR	0x22c

#define SUM  	0x230
#define SUM0 	0x231
#define SUMR 	0x232
#define MEAN 	0x233
#define S_DEV	0x234
#define NSTAT	0x235
#define FACT	0x236
#define PERM	0x237
#define COMB	0x238
#define LR	0x239
#define CALCY	0x23a
#define MEANY	0x23b

#define NFIN 	0x240
#define INTST	0x241
#define PMT  	0x242
#define PVAL 	0x243
#define FVAL 	0x244
#define FCLR	0x245
#define BEGIN	0x246
#define DYS	0x247
#define TDY	0x248
#define TIMES12	0x249
#define DIVIDE12	0x24a

#define	LENGTH	0x250
#define	AREA	0x251
#define	VOLUME	0x252
#define	MASS	0x253
#define	SPEED	0x254
#define	FUEL	0x255
#define	PRES	0x256
#define	TEMP	0x257

#define AND	0x260
#define OR	0x261
#define NOT	0x262
#define XOR	0x263
#define SHIFTYL 0x264
#define SHIFTYR 0x265
#define SHIFTL	0x266
#define SHIFTR	0x267
#define PRIMEF	0x268

#define PLUS	0x280
#define MINUS	0x281
#define MULT	0x282
#define DIVIDE	0x283
#define PERCENT	0x284
#define PERCENTCH 0x285
#define MODULUS 0x286
#define	CHS	0x287
#define YTOX	0x288

#define ROLLDOWN 0x290
#define CLX      0x291
#define QUIT	 0x292
#define NEXTKEYS 0x293
#define PREVKEYS 0x294
#define ENTER	 0x295
#define	XNL	 0x296
#define	XNT	 0x297
#define	XNZ	 0x298
#define	XNY	 0x299
#define	LASTX	 0x29a
#define STORE	 0x29b
#define STOPLUS	 0x29c
#define STOMINUS 0x29d
#define RECALL	 0x29e 
#define COPY	 0x29f 
#define	PASTE	 0x2a0
#define CLU	 0x2a1
#define CLR	 0x2a2

#define HELP	 0x2b0
#define NOP	 0x2b1

/* ... END OF COMMANDS */

#define BOOLEAN int

#define NUMREGS 10
#define STAT_R2		1
#define STAT_Y_INT	2
#define STAT_SLOPE	3
#define STAT_NUM_REG	4
#define STAT_SUMX_REG	5
#define STAT_SUMY_REG	6
#define STAT_SUMX2_REG	7
#define STAT_SUMY2_REG	8
#define STAT_SUMXY_REG	9
#define FIN_NUM_REG	5
#define FIN_INT_REG	6
#define FIN_PVAL_REG	7
#define FIN_PMT_REG	8
#define FIN_FVAL_REG	9
#define MSG_SIZE 	42
#define KMaxPrimes 	9

#define DEF_SIG(x) "DCALC Version " x " - by Bob Hepple"

/* Function prototypes: */

/* imported by dcalc - supplied by curses, hpcalc, ibm etc */
extern void print_string(char *buf);
extern void prinbase(void);
extern void print_inv(void);
extern void print_deg(void);
extern void print_x(char *buf);
extern void dispnums(void);
extern void dispreg(int);
extern void dispregs(void);
extern void put_a_char(int i);
extern int get_a_char(int *);
extern void msg(char *buf);
extern void clear_msg(void);
extern void pop_up_reg(void);
extern void pop_up_help(void);
extern void os_raw_mode(int);
extern void os_init(void);
extern void os_term(void);
extern int dialog(char *buf);
extern int places(char *buf);
extern int store(char *buf);
extern int recall(char *buf);
extern void saveGuiSettings(FILE *f);
extern void readGuiSettings(char *b);

/* exported by dcalc.c: */
extern void fmt_bin(char *str, long x);
extern void fmt_base(char *s, long x, double xf);
extern void prep_for_output(char *string);
extern void initialise(void);
extern int process(COMMAND c);
extern void iProcess(COMMAND c, int i);
extern void terminate(void);
extern void display(void);
extern int base, decplaces, entering, invert, degree, mode, intmode, floatmode, finPayAt0;
extern long x, y, z, t, l, reg[NUMREGS];
extern double xf, yf, zf, tf, lf, regf[NUMREGS];
extern char inbuf[45];
extern void convertX(char *from, char *to);

/* For emacs: */

/* Local Variables: */
/* eval:(setq tab-width 8) */
/* End: */
