/*
 * DCALC: OPENWIN specific parts of DCALC.
 */

#include <stdio.h>
#include <signal.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <xview/font.h>
#include <gdd.h>
#include "ov_ui.h"
#include "dcalc.h"

ov_dcalc_objects	*ov_dcalc;
ov_registers_objects	*ov_registers;
ov_help_objects		*ov_help;
Xv_Font			fixed, default_font;


Xv_opaque 		field;
int 			is_resident = 0;
char			pushed_char = 0;

extern int 		base,
    			entering,
    			degree,
    			fk_set;
extern struct funckey	func[NUMFK][8];

os_init() 
{
}

os_term() 
{
}

quit(item, event)
    Panel_item	item;
    Event	*event;
{
    int		result;
    Panel	panel = (Panel)xv_get(item, PANEL_PARENT_PANEL);
/*  Window	win;
    Window	root = (Window)xv_get(xv_get(panel, XV_ROOT), XV_XID);
    int		x, y;

    XTranslateCoordinates(xv_get(panel, XV_DISPLAY),
			  xv_get(panel, XV_XID), root, 
			  event_x(event),
			  event_y(event),
			  &x, &y, &win); ... doesn't work! */
    result = notice_prompt(panel, NULL,
			   NOTICE_MESSAGE_STRINGS, "Really quit?", NULL,
/*  not working ...	   NOTICE_FOCUS_XY, x, y, */
			   NOTICE_BUTTON_YES, "Yes",
			   NOTICE_BUTTON_NO, "No", 
/* otherwise inherits the font of the window where it was picked - and
   if that is 'fixed', there is not enough room for the 'Yes' text ... */
			   NOTICE_FONT, default_font,
			   NULL);
    if (result == NOTICE_YES)
	xv_destroy_safe(ov_dcalc->dcalc);
}

COMMAND map_key_to_func(c, item, event)
    COMMAND 	c;
    Panel_item	item;
    Event	*event;
{
    if ((base == 1) && (c > 0) && (c < 256))
	    return(c);
   
    if ((base == 16) && (((c >= 'a') && (c <= 'f')) || ((c >= 'A') && (c <= 'F'))))
	return(c);

    if ((c >= KEY_TOP(1)) && (c <= KEY_TOP(8)))
	    return(func[fk_set][c - KEY_TOP(1)].function);

    switch (c) {

    case '\027': /* ^W = f1 */
	return(func[fk_set][0].function);
    case '\005': /* ^E = f2 */
	return(func[fk_set][1].function);
    case '\022': /* ^R = f3 */
	return(func[fk_set][2].function);
    case '\024': /* ^T = f4 */
	return(func[fk_set][3].function);
    case '\031': /* ^Y = f5 */
	return(func[fk_set][4].function);
    case '\025': /* ^U = f6 */
	return(func[fk_set][5].function);
    case '\011': /* ^I = f7 */
	return(func[fk_set][6].function);
    case '\017': /* ^O = f8 */
	return(func[fk_set][7].function);
	
    case KEY_RIGHT(14):
    case 'D':
    case 'd':
	return(ROLLDOWN);
	
    case KEY_RIGHT(15):
    case '\016': /* ^N */
	return(NEXTKEYS);
	
    case KEY_RIGHT(9):
    case '\020': /* ^P */
	return(PREVKEYS);
	
    case 'C':
    case 'c':
	return(CLX);
	
    case '\004':	/* ^D */        
    case 'Q':
    case 'q':
    case ESCAPE:
	quit(item, event);
	return(NOP);

    case KEY_RIGHT(8):
    case '\n':
    case '\r':
	return(ENTER);
	
    case '\014': /* ^L */
	return(NOP);
	
    default:
	return(toupper(c));
    }
}

prep()
{
    xwin_select();
    clear_msg();
}
    
/*
 * Event callback function for `display'.
 */
void key_hit(item, event)
    Panel_item      item;
    Event           *event;
{
    COMMAND		id;
    
    ov_dcalc_objects      *ip = 
	(ov_dcalc_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
    
    id = event_id(event);
    if (event_is_down(event))
	if (event_is_ascii(event) || 
	    event_is_key_top(event) ||
	    event_is_key_right(event)) {
	    id = map_key_to_func(id, item, event);
	    prep();
	    process(&id);
	    return;
	}
    panel_default_handle_event(item, event);
}

#define b_hit(x) \
    Panel_item item; \
    Event *event; \
{ \
    COMMAND 	c = x; \
\
    panel_default_handle_event(item, event); \
    if (event_is_down(event) && (event_action(event) == ACTION_SELECT)) { \
        prep(); \
        process(&c); \
    } \
}

void b0_hit(item, event) 	b_hit('0')
void b1_hit(item, event) 	b_hit('1')
void b2_hit(item, event) 	b_hit('2')
void b3_hit(item, event)	b_hit('3')
void b4_hit(item, event) 	b_hit('4')
void b5_hit(item, event) 	b_hit('5')
void b6_hit(item, event) 	b_hit('6')
void b7_hit(item, event) 	b_hit('7')
void b8_hit(item, event) 	b_hit('8')
void b9_hit(item, event) 	b_hit('9')
void ba_hit(item, event) 	b_hit('A')
void bb_hit(item, event) 	b_hit('B')
void bc_hit(item, event) 	b_hit('C')
void bd_hit(item, event) 	b_hit('D')
void be_hit(item, event) 	b_hit('E')
void bf_hit(item, event) 	b_hit('F')
void enter_hit(item, event) 	b_hit(ENTER)
void chs_hit(item, event) 	b_hit(',')
void x_y_hit(item, event) 	b_hit('X')
void roll_hit(item, event) 	b_hit(ROLLDOWN)
void power_hit(item, event) 	b_hit('Y')
void percent_hit(item, event) 	b_hit('%')
void mod_hit(item, event) 	b_hit('#')
void or_hit(item, event) 	b_hit('|')
void and_hit(item, event) 	b_hit('&')
void xor_hit(item, event) 	b_hit('^')
void not_hit(item, event) 	b_hit('~')
void pi_hit(item, event) 	b_hit('P')
void shiftl_hit(item, event) 	b_hit('<')
void shiftr_hit(item, event) 	b_hit('>')
void plus_hit(item, event) 	b_hit('+')
void minus_hit(item, event) 	b_hit('-')
void mult_hit(item, event) 	b_hit('*')
void divide_hit(item, event) 	b_hit('/')
void lastx_hit(item, event) 	b_hit('L')
void clear_hit(item, event) 	b_hit(SUM0)
void clearx_hit(item, event) 	b_hit(CLX)
void register_hit(item, event)	b_hit('@')
void cos_hit(item, event)	b_hit(COS)
void periods_hit(item, event)	b_hit(NFIN)
void frc_hit(item, event)	b_hit(FRC)
void tan_hit(item, event)	b_hit(TAN)
void sum_hit(item, event)	b_hit(SUM)
void square_hit(item, event)	b_hit(SQR)
void n_hit(item, event)		b_hit(NSTAT)
void sin_hit(item, event)	b_hit(SIN)
void root_hit(item, event)	b_hit(ROOT)
void sumless_hit(item, event)	b_hit(SUMR)
void pmt_hit(item, event)	b_hit(PMT)
void sdev_hit(item, event)	b_hit(S_DEV)
void mean_hit(item, event)	b_hit(MEAN)
void bdot_hit(item, event)	b_hit('.')
void loge_hit(item, event)	b_hit(LOGE)
void bbs_hit(item, event)	b_hit(BACKSPACE)
void fval_hit(item, event)	b_hit(FVAL)
void log10_hit(item, event)	b_hit(LOG10)
void interest_hit(item, event)	b_hit(INTST)
void pval_hit(item, event)	b_hit(PVAL)
void int_hit(item, event)	b_hit(INT)
void inv_hit(item, event)	b_hit(INV)
void reciprocal_hit(item, event) b_hit(RECI)
void e_to_x_hit(item, event)	b_hit(ETOX)
void bdeg_rad(item, event)	b_hit('M')

void bquit_hit(item, event)
    Panel_item item; 
    Event *event; 
{ 
    COMMAND 	c = QUIT; 

    /*panel_default_handle_event(item, event); */
    if (event_is_down(event) && (event_action(event) == ACTION_SELECT))
	quit(item, event);
}

/*
 * Menu handler for `base_menu (Ascii)'.
 */
#define p_hit(x) \
	Menu_item	item; \
	Menu_generate	op; \
{ \
    COMMAND	c = x; \
 \
    if (op == MENU_NOTIFY) { \
	prep(); \
        process(&c); \
    } \
    return item; \
}

Menu_item binary_hit(item, op)	p_hit(BIN)
Menu_item octal_hit(item, op)	p_hit(OCT)
Menu_item decimal_hit(item, op)	p_hit(DEC)
Menu_item hex_hit(item, op)	p_hit(HEX)
Menu_item ascii_hit(item, op)	p_hit(ASCIIM)

/*
 * Menu handler for `eng_menu (X)'.
 */
#define eng_hit(x) \
	Menu_item	item; \
	Menu_generate	op; \
{ \
	COMMAND		c = ENG; \
 \
	if (op == MENU_NOTIFY) { \
	        pushed_char = x; \
		prep(); \
		process(&c); \
	} \
	return item; \
}

Menu_item eng_0_hit(item, op) eng_hit('0')
Menu_item eng_1_hit(item, op) eng_hit('1')
Menu_item eng_2_hit(item, op) eng_hit('2')
Menu_item eng_3_hit(item, op) eng_hit('3')
Menu_item eng_4_hit(item, op) eng_hit('4')
Menu_item eng_5_hit(item, op) eng_hit('5')
Menu_item eng_6_hit(item, op) eng_hit('6')
Menu_item eng_7_hit(item, op) eng_hit('7')
Menu_item eng_8_hit(item, op) eng_hit('8')
Menu_item eng_9_hit(item, op) eng_hit('9')

/*
 * Menu handler for `float_menu (X)'.
 */
#define float_hit(x) \
	Menu_item	item; \
	Menu_generate	op; \
{ \
	COMMAND		c = FLOAT; \
 \
	if (op == MENU_NOTIFY) { \
	        pushed_char = x; \
		prep(); \
		process(&c); \
	} \
	return item; \
}

Menu_item float_0_hit(item, op) float_hit('0')
Menu_item float_1_hit(item, op) float_hit('1')
Menu_item float_2_hit(item, op) float_hit('2')
Menu_item float_3_hit(item, op) float_hit('3')
Menu_item float_4_hit(item, op) float_hit('4')
Menu_item float_5_hit(item, op) float_hit('5')
Menu_item float_6_hit(item, op) float_hit('6')
Menu_item float_7_hit(item, op) float_hit('7')
Menu_item float_8_hit(item, op) float_hit('8')
Menu_item float_9_hit(item, op) float_hit('9')

/*
 * Menu handler for `store_menu (X)'.
 */
#define store_hit(x) \
	Menu_item	item; \
	Menu_generate	op; \
{ \
	COMMAND		c = 'S'; \
 \
	if (op == MENU_NOTIFY) { \
	        pushed_char = x; \
		prep(); \
		process(&c); \
	} \
	return item; \
}

Menu_item store_0_hit(item, op) store_hit('0')
Menu_item store_1_hit(item, op) store_hit('1')
Menu_item store_2_hit(item, op) store_hit('2')
Menu_item store_3_hit(item, op) store_hit('3')
Menu_item store_4_hit(item, op) store_hit('4')
Menu_item store_5_hit(item, op) store_hit('5')
Menu_item store_6_hit(item, op) store_hit('6')
Menu_item store_7_hit(item, op) store_hit('7')
Menu_item store_8_hit(item, op) store_hit('8')
Menu_item store_9_hit(item, op) store_hit('9')

/*
 * Menu handler for `recall_menu (X)'.
 */
#define recall_hit(x) \
	Menu_item	item; \
	Menu_generate	op; \
{ \
	COMMAND		c = 'R'; \
 \
	if (op == MENU_NOTIFY) { \
	        pushed_char = x; \
		prep(); \
		process(&c); \
	} \
	return item; \
}

Menu_item recall_0_hit(item, op) recall_hit('0')
Menu_item recall_1_hit(item, op) recall_hit('1')
Menu_item recall_2_hit(item, op) recall_hit('2')
Menu_item recall_3_hit(item, op) recall_hit('3')
Menu_item recall_4_hit(item, op) recall_hit('4')
Menu_item recall_5_hit(item, op) recall_hit('5')
Menu_item recall_6_hit(item, op) recall_hit('6')
Menu_item recall_7_hit(item, op) recall_hit('7')
Menu_item recall_8_hit(item, op) recall_hit('8')
Menu_item recall_9_hit(item, op) recall_hit('9')

#define XWIN	1
#define REGWIN	2
int win_selected = XWIN;

xwin_select()
{
    win_selected = XWIN;
}

reg_select()
{
    win_selected = REGWIN;
    return(1);
}

pop_up_reg()
{
    if ((int) xv_get(ov_registers->registers, XV_SHOW, NULL) == FALSE) {
	dispnums();
	dispregs();
	xv_set(ov_registers->registers, 
	       XV_SHOW, TRUE,
	       NULL);
    } else
	xv_set(ov_registers->registers, 
	       XV_SHOW, FALSE,
	       NULL);
}

pop_up_help()
{
}

clear_msg()
{
    msg(" ");
}

int get_a_char(d)
    int	*d;
{
    int	retval = pushed_char;

    if (pushed_char)
	pushed_char = 0;
    *d = 0;
    return(retval);
}

gotoxy(x, y)
    int x, y;
{
    if (win_selected == XWIN) {
	if ((x == BASE_X) && (y == BASE_Y))
	    field = ov_dcalc->base_text;
	else if ((x == INV_X) && (y == INV_Y))
	    field = ov_dcalc->inv_text;
	else if ((x == TMODE_X) && (y == TMODE_Y))
	    field = ov_dcalc->mode_text;
	else if ((x == LEFTSIDE) && (y == STARTX_Y))
	    field = ov_dcalc->display;
	else
	    field = NULL;
    } else if (win_selected == REGWIN)
	if (x == LEFTSIDE)
	    field = NULL;
	else
	    switch (y) {
	    case STARTL_Y: field = ov_dcalc->rl; break;
	    case STARTY_Y: field = ov_dcalc->ry; break;
	    case STARTZ_Y: field = ov_dcalc->rz; break;
	    case STARTT_Y: field = ov_dcalc->rt; break;
	    case 0: field = ov_registers->r0; break;
	    case 1: field = ov_registers->r1; break;
	    case 2: field = ov_registers->r2; break;
	    case 3: field = ov_registers->r3; break;
	    case 4: field = ov_registers->r4; break;
	    case 5: field = ov_registers->r5; break;
	    case 6: field = ov_registers->r6; break;
	    case 7: field = ov_registers->r7; break;
	    case 8: field = ov_registers->r8; break;
	    case 9: field = ov_registers->r9; break;
	    default: field = NULL; break;
	    }
}

msg(s)
    char *s;
{
    xv_set(ov_dcalc->dcalc, FRAME_LEFT_FOOTER, s, NULL);
}

print_fk(){}

print_string(s)
    char *s;
{
    if (field)
	xv_set(field, PANEL_VALUE, s, NULL);
}

put_a_char()
{
    fprintf(stderr, "\007");
}

void print_base(x, xf)
    long	x;
    double	xf;
{
    fmt_base(outbuf, x, xf);
    prep_for_output(outbuf);
    print_string(outbuf);
}
  
void dispreg(i)
    int	i;
{
    if (reg_select()) {
	gotoxy(LEFTSIDE, i);
	outbuf[0] = '0' + i;
	outbuf[1] = '\0';
	print_string(outbuf);
	gotoxy(START_X, i);
	print_base(reg[i], regf[i]);
    }
}

void dispregs()
{
    int i;
    
    for (i = 0; i < NUMREGS; i++)
	dispreg(i);
}

void prinbase()
{
    xwin_select();
    gotoxy(BASE_X, BASE_Y);
    switch (base) {
    case 1:
	print_string("Ascii   ");
	break;
	
    case 2:
	print_string("Binary  ");
	break;
	
    case 8:
	print_string("Octal   ");
	break;
	
    case 10:
	print_string("Decimal ");
	break;
	
    case 16:
	print_string("Hex     ");
	break;
	
    default:
	if (base < -9) {
	    sprintf(outbuf, "Engin. %d", -(base + 10));
	    print_string(outbuf);
	} else {
	    sprintf(outbuf, "Float  %d", -base);
	    print_string(outbuf);
	}
	break;
    }
}

void print_inv()
{
    xwin_select();
    gotoxy(INV_X, INV_Y);
    if (invert)
	print_string("Inv   ");
    else
	print_string("      ");
}

void print_deg()
{
    xwin_select();
    gotoxy(TMODE_X, TMODE_Y);
    if (degree)
	print_string("Degrees");
    else
	print_string("Radians");
}

void print_x(char *buf) 
{
    gotoxy(LEFTSIDE, STARTX_Y);
    print_string(buf);
}

void dispnums()
{
    xwin_select();
    gotoxy(LEFTSIDE, STARTX_Y);
    if (entering) {
	strcpy(outbuf, inbuf);
	prep_for_output(outbuf);
	print_string(outbuf);
    } else
	print_base(x, xf);
    
    if (reg_select()) {
	gotoxy(LEFTSIDE, STARTT_Y);
	print_string("T");
	gotoxy(START_X, STARTT_Y);
	print_base(t, tf);
	
	gotoxy(LEFTSIDE, STARTZ_Y);
	print_string("Z");
	gotoxy(START_X, STARTZ_Y);
	print_base(z, zf);
	
	gotoxy(LEFTSIDE, STARTY_Y);
	print_string("Y");
	gotoxy(START_X, STARTY_Y);
	print_base(y, yf);
	
	gotoxy(LEFTSIDE, STARTL_Y);
	print_string("L");
	gotoxy(START_X, STARTL_Y);
	print_base(l, lf);
    }
}

/*
 * Instance XV_KEY_DATA key.  An instance is a set of related
 * user interface objects.  A pointer to an object's instance
 * is stored under this key in every object.  This must be a
 * global variable.
 */
Attr_attribute	INSTANCE;

void
    main(argc, argv)
int		argc;
char		**argv;
{
    /*
     * Initialize XView.
     */
    xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, 0);
    INSTANCE = xv_unique_key();
    
    /*
     * Initialize user interface components.
     */
    ov_dcalc = ov_dcalc_objects_initialize(NULL, NULL);
    ov_registers = ov_registers_objects_initialize(NULL, ov_dcalc->dcalc);
    ov_help = ov_help_objects_initialize(NULL, ov_dcalc->dcalc);

    default_font = xv_get(ov_dcalc->dcalc, XV_FONT);
    fixed = xv_find(ov_dcalc->dcalc, FONT, FONT_NAME, "fixed", NULL);
    xv_set(ov_dcalc->controls1, XV_FONT, default_font, NULL);
    xv_set(ov_registers->controls2, XV_FONT, fixed, NULL);
    xv_set(ov_dcalc->controls3, XV_FONT, fixed, NULL);
    xv_set(ov_dcalc->controls4, XV_FONT, default_font, NULL);
    
    /*
     * Initialise dcalc
     */
    initialise();
    display();
    msg(DEF_SIG);
    dispnums();
    dispregs();
    
    /*
     * Turn control over to XView.
     */
    xv_main_loop(ov_dcalc->dcalc);
    exit(0);
}
